config/routes.rb
Rails.application.routes.draw do

  resources :diplomas
  devise_for :centers,
             :path=>'recruteur',
             :path_names=>{:sign_in=>'login', :edit=>'profile'},
             :controllers=>{
                 :registrations=>'centers/registrations',
                 :sessions=>'centers/sessions'
             }

  devise_for :users,
             :path=>'',
             :path_names=>{:sign_in=>'login', :sign_out=>'logout', :edit=>'profile'},
             :controllers=>{
                 :registrations=>'users/registrations',
                 :sessions=>'users/sessions'
             }

  resources :users do
    get :matching_offers
  end
  resources :centers
  resources :availabilities
  resources :circonscriptions
  resources :offers
  resources :schools

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  # root page of the application
  root 'pages#home'

  get '/search' => 'pages#search'
end

app/models/offer.rb
class Offer < ApplicationRecord
  belongs_to :center
  belongs_to :school
  has_and_belongs_to_many :diplomas

  validates :date, presence:true
  validates :time_slot, presence:true
  validates :diplomas, presence:true
  validates :offer_number, presence:true

end

app/controllers/offers_controller.rb
class OffersController < ApplicationController
  before_action :set_offer, only: [:show, :edit, :update, :destroy]
  load_and_authorize_resource

  # GET /offers
  # GET /offers.json
  def index
    @offers = Offer.all.order(:date).where('date >= ?', DateTime.now.to_date)
  end

  # GET /offers/1
  # GET /offers/1.json
  def show
  end

  # GET /offers/new
  def new
    @offer = Offer.new
  end

  # GET /offers/1/edit
  def edit
  end

  # POST /offers
  # POST /offers.json
  def create
    @offer = Offer.new(offer_params)
    @offer.center = current_center

      if @offer.save
         redirect_to offers_url, notice: "L'Offre a été créée avec succès"
      else
        render :new
      end
  end

  # PATCH/PUT /offers/1
  # PATCH/PUT /offers/1.json
  def update
    @offer.center = current_center
    if @offer.update(offer_params)
      redirect_to center_path(current_center), notice: "L'Offre a été modifiée avec succès"
    else
      render :edit
    end
  end

  # DELETE /offers/1
  # DELETE /offers/1.json
  def destroy
    @offer.destroy
    respond_to do |format|
      format.html { redirect_to offers_url, notice: 'Offer was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_offer
      @offer = Offer.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def offer_params
      params.require(:offer).permit(:date, :time_slot, :offer_number, :school_id, :center_id, :diploma_ids => []);
    end
end

app/helpers/offer_helper.rb
module OfferHelper
end

app/helpers/offers_helper.rb
module OffersHelper
end

app/views/offers/edit.html.erb
<div class="container">
  <div class="col-md-8 col-sm-12 col-md-offset-2 form-flex form-panel_wrapper">
      <%= form_for @offer do |f| %>
        <div class="panel panel-default">
          <div class="panel-heading">
            <div class="form-heading-title">Modifier l'offre</div>
          </div>
          <div class="panel-body">
            <div class="form-group">
              <%= f.label :school_id, 'Ecole', class: 'control-label'%>
              <%= f.collection_select :school_id, current_center.schools, :id, :name, {}, { class: 'form-control' } %>
            </div>
            <div class="form-group">
              <%= f.label :date, 'Date', class: 'control-label'%>
              <%= f.text_field :date, id: 'offer-date', class: 'form-control', placeholder: 'Date', :required => true %>
            </div>
            <div class="form-group">
              <%= f.label :time_slot, 'Plage horaire', class: 'control-label'%>
              <%= f.select :time_slot, options_for_select(
                  [
                      ["Interclasse", "Interclasse"],
                      ["Centre de Loisirs", "Centre de Loisirs"],
                      ["Goûter / Etude", "Goûter / Etude"],
                      ["TAP", "TAP"]
                  ]
              ), {include_blank: false}, {class: 'form-control'} %>
            </div>
            <div class="form-group required">
              <%= f.label :diploma, 'Diplôme requis', class: 'control-label'%>
              <div class="dropdown">
                <button class="btn btn-default dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
                  Choisir un ou plusieurs diplômes
                  <span class="caret"></span>
                </button>
                <ul class="dropdown-menu" aria-labelledby="dropdownMenu1">
                  <%= f.collection_check_boxes :diploma_ids, Diploma.all, :id, :name do |b| %>
                      <li>
                        <%= b.check_box %>
                        <%= b.label %>
                      </li>
                  <% end %>
                </ul>
              </div>
            </div>
            <div class="form-group">
              <%= f.label :offer_number, 'Nombre de postes à pourvoir', class: 'control-label'%>
              <%= f.number_field :offer_number, class: 'form-control', :value => '1' ,:required => true %>
            </div>

          </div> <!-- .panel-body -->
        </div> <!-- .panel -->
        <%= f.submit t('.submit', default: "Modifier l'offre"), class: 'btn btn-edit-form' %>
        <% end %> <!-- form -->
  </div>
</div>

<script>
    $(function(){
        $('#offer-date').datepicker({
            dateFormat: 'yy-mm-dd',
            monthNames: ['Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre'],
            dayNamesMin: ['D','L','M','M','J','V','S'],
            minDate: 0,
            beforeShowDay: $.datepicker.noWeekends,
            firstDay: 1
        })
    })
</script>

app/views/offers/index.html.erb
<div class="container">

  <div class="col-md-10 col-md-offset-1">

    <h2>Toutes les offres de vacation (<%= @offers.count %>)</h2>

    <% @offers.each do |offer| %>

        <div class="panel panel-default offers-item">
          <div class="offer-desc">
            <div class="offer-desc_school">
              <%= link_to school_path(offer.school) do %>
                <div class="offer-desc_school_name"><%= offer.school.name.titleize %></div>
                <div class="offer-desc_school_address"><%= offer.school.address %></div>
            <% end %>
            </div>
            <div class="offer-desc_date">
              <div class="offer-desc_date_day">
                <div><i class="fa fa-calendar-o "></i> <%= l offer.date.to_date, format: '%A' %> <%= l offer.date.to_date, format: :long %></div>

              </div>
              <div class="offer-desc_date_time_slot badge tealish"><i class="fa fa-clock-o fa-lg"></i> <%= offer.time_slot %></div>
              <% if offer.date.to_date == DateTime.now.to_date %>
                  <div class="offer-desc_date_urgent badge urgent"><i class="fa fa-exclamation fa-lg"></i> Urgent</div>
              <% end %>
              <div class="offer-tags">
                <% offer.diplomas.each do |diploma|  %>
                    <div class="offer-tags_diploma <%= diploma.name != "Aucun diplôme" ? "badge butterscotch" : "badge" %>">
                      <i class="fa fa-graduation-cap fa-lg"></i><%= diploma.name %></div>
                <% end %>
              </div>
            </div>

          </div>


          <% if user_signed_in? %>
            <div class="offer-apply">
              <div class="btn btn-pink" data-toggle="modal" data-target="#center-<%= offer.id %>">Postuler</div>
            </div>
            <!-- Modal -->
            <div class="modal fade" id="center-<%= offer.id %>" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
              <div class="modal-dialog" role="document">
                <div class="modal-content offer-call-school">
                  <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title" id="myModalLabel">Vacation du <%= l offer.date.to_date, format: '%A' %> <%= l offer.date.to_date, format: :long %>
                    </h4>
                    <div class="offer-desc_date_time_slot badge tealish"><i class="fa fa-clock-o fa-lg"></i> <%= offer.time_slot %></div>
                    <span class="offer-tags_diploma <%= offer.diploma=="Bafa" ? "badge butterscotch" : "badge" %>">
                      <i class="fa fa-graduation-cap fa-lg"></i> <%= offer.diploma %>
                    </span>
                    <% if offer.date.to_date == DateTime.now.to_date %> <span class="offer-desc_date_urgent badge urgent"><i class="fa fa-exclamation fa-lg"></i> Urgent</span>
                    <% end %>
                  </div>
                  <div class="modal-body">
                    <h4>Appelez directement le Centre de Loisirs pour postuler</h4>
                    <div>Ecole <%= offer.school.name.titleize %></div>
                    <div>
                    <div><%= offer.center.first_name %> <%= offer.center.last_name %> </div>
                    <div class="offer-call-number"><i class="fa fa-phone fa-lg tealish-font"></i> <a class="tealish-font" href="tel:<%= offer.center.phone_number %>"><%= offer.center.phone_number %></a></div>
                    </div>
                  </div>
                  <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Fermer</button>
                  </div>
                </div>
              </div>
            </div>
        <% end %>
        </div>
    <% end %>

  </div>
</div>

<script>

  $(".offers-item")
      .mouseenter(function() {
          $(this).children(".offer-apply").css("opacity", "1");
      })
      .mouseleave(function() {
          $(this).children(".offer-apply").css("opacity", "0");
      })

</script>

app/views/offers/new.html.erb
<div class="container">
  <div class="col-md-8 col-sm-12 col-md-offset-2 form-flex form-panel_wrapper">
      <%= form_for @offer do |f| %>
        <div class="panel panel-default">
          <div class="panel-heading">
            <div class="form-heading-title">Créer une nouvelle offre de vacation animateur</div>
          </div>
          <div class="panel-body">
            <div class="form-group">
              <%= f.label :school_id, 'Ecole', class: 'control-label'%>
              <%= f.collection_select :school_id, current_center.schools, :id, :name, {}, { class: 'form-control' } %>
            </div>
            <div class="form-group">
              <%= f.label :date, 'Date', class: 'control-label'%>
              <%= f.text_field :date, id: 'offer-date', class: 'form-control', placeholder: 'Date', :required => true %>
            </div>
            <div class="form-group">
              <%= f.label :time_slot, 'Plage horaire', class: 'control-label'%>
              <%= f.select :time_slot, options_for_select(
                  [
                      ["Interclasse", "Interclasse"],
                      ["Centre de Loisirs", "Centre de Loisirs"],
                      ["Goûter / Etude", "Goûter / Etude"],
                      ["TAP", "TAP"]
                  ]
              ), {include_blank: false}, {class: 'form-control'} %>
            </div>
            <div class="form-group required">
              <%= f.label :diploma, 'Diplôme requis', class: 'control-label'%>
                <div class="dropdown">
                  <button class="btn btn-default dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
                    Choisir un ou plusieurs diplômes
                    <span class="caret"></span>
                  </button>
                  <ul class="dropdown-menu" aria-labelledby="dropdownMenu1">
                    <%= f.collection_check_boxes :diploma_ids, Diploma.all, :id, :name do |b| %>
                      <li>
                        <%= b.check_box %>
                        <%= b.label %>
                      </li>
                    <% end %>
                  </ul>
                </div>
            </div>
            <div class="form-group">
              <%= f.label :offer_number, 'Nombre de postes à pourvoir', class: 'control-label'%>
              <%= f.number_field :offer_number, class: 'form-control', :value => '1' ,:required => true %>
            </div>

      </div> <!-- .panel-body -->
    </div> <!-- .panel -->
          <%= f.submit t('.submit', default: "Créer l'offre"), class: 'btn btn-edit-form' %>
      <% end %> <!-- form -->
  </div>
</div>

<script>
    $(function(){
        $('#offer-date').datepicker({
            dateFormat: 'yy-mm-dd',
            monthNames: ['Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre'],
            dayNamesMin: ['D','L','M','M','J','V','S'],
            minDate: 0,
            beforeShowDay: $.datepicker.noWeekends,
            firstDay: 1
        })
    })
</script>

app/views/offers/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Edit', edit_offer_path(@offer) %> |
<%= link_to 'Back', offers_path %>